--- libmp3lame/takehiro.c.orig	2011-05-08 01:05:17.000000000 +0900
+++ libmp3lame/takehiro.c	2011-10-16 02:38:59.000000000 +0900
@@ -643,7 +1508,11 @@
             break;
         }
     }
+#if defined(ALTIVEC) && defined(ALTIVEC_970)
+    return count_bit_ESC_altivec(ix, end, choice, choice2, s);
+#else
     return count_bit_ESC(ix, end, choice, choice2, s);
+#endif
 }
 
 
--- libmp3lame/util.c.orig	2012-01-10 19:08:47.000000000 +0900
+++ libmp3lame/util.c	2012-01-10 20:26:53.000000000 +0900
@@ -26,6 +26,12 @@
 # include <config.h>
 #endif
 
+#if defined(ALTIVEC) && !defined(ALTIVEC_970)
+#ifndef __APPLE_CC__
+#include <altivec.h>
+#endif
+#endif
+
 #include "lame.h"
 #include "machine.h"
 #include "encoder.h"
@@ -945,6 +951,108 @@
  *
  ***********************************************************************/
 
+#if defined(ALTIVEC) && !defined(ALTIVEC_970)
+
+inline ieee754_float32_t fast_log10_altivec(ieee754_float32_t x)
+{
+    vector float va,vb,vc,vhalf,vzero,vsqrt2,vconst4;
+    vector float v1,v2,v3,v4,v5,v6,v7,v8,vz,vz2,vlog;
+    vector unsigned int vconst1,vconst2,vshamt;
+    vector signed int vconst3;
+    float out __attribute__ ((aligned (16)));
+    
+    va = (vector float)VINIT4ALL(0.8685890659);
+    vb = (vector float)VINIT4ALL(0.2894672153);
+    vc = (vector float)VINIT4ALL(0.1793365895);
+    vhalf = (vector float)VINIT4ALL(0.15051499783);
+    vsqrt2 = (vector float)VINIT4ALL(1.4142135623731);
+    vconst4 = (vector float)VINIT4ALL(0.301029995664);
+    vzero = vec_xor(vzero,vzero);
+    vconst1 = (vector unsigned int)vec_sr(vec_splat_s32(-1),vec_splat_u32(9));
+    vconst2 = (vector unsigned int)vec_sr(vec_splat_s32(-1),vec_splat_u32(7));
+    vconst2 = vec_nor(vconst2,vconst2);
+    vconst3 = (vector signed int)vec_rl(vconst2,vec_splat_u32(7));
+    vshamt = vec_add(vec_splat_u32(9),vec_splat_u32(7));
+    vshamt = vec_add(vshamt,vec_splat_u32(7));
+    vconst2 = vec_sl((vector unsigned int)vconst3,vshamt);
+    
+    v1 = vec_ld(0,&x);
+    v2 = vec_perm(v1,v1,vec_lvsl(0,&x));
+    v3 = vec_splat(v2,0);
+    
+    v4 = (vector float)vec_sel(vconst2,(vector unsigned int)v3,vconst1);
+    v5 = vec_add(v4,vsqrt2);
+    v6 = vec_sub(v4,vsqrt2);
+    v7 = vec_re(v5);
+    vz = vec_madd(v6, vec_madd(vec_nmsub(v7,v5,(vector float)vconst2),v7,v7), vzero);
+    v8 = (vector float)vec_sr((vector unsigned int)v3,vshamt);
+    vlog = vec_ctf(vec_sub((vector signed int)v8,vconst3),0);
+    
+    vz2 = vec_madd(vz,vz,vzero);
+    vlog = vec_madd(vlog,vconst4,vhalf);
+    
+    v1 = vec_madd(vz2,vc,vb);
+    v2 = vec_madd(vz2,v1,va);
+    vlog = vec_madd(vz,v2,vlog);
+    
+    vec_ste(vlog,0,&out);
+    
+    return out;
+}
+
+inline ieee754_float32_t fast_loge_altivec(ieee754_float32_t x)
+{
+    vector float va,vb,vc,vhalf,vzero,vsqrt2,vconst4;
+    vector float v1,v2,v3,v4,v5,v6,v7,v8,vz,vz2,vlog;
+    vector unsigned int vconst1,vconst2,vshamt;
+    vector signed int vconst3;
+    float out __attribute__ ((aligned (16)));
+    
+    va = (vector float)VINIT4ALL(2.0000006209);
+    vb = (vector float)VINIT4ALL(0.6664778517);
+    vc = (vector float)VINIT4ALL(0.4139745860);
+    vhalf = (vector float)VINIT4ALL(0.34657359028);
+    vsqrt2 = (vector float)VINIT4ALL(1.4142135623731);
+    vconst4 = (vector float)VINIT4ALL(0.6931471805599);
+    vzero = vec_xor(vzero,vzero);
+    vconst1 = (vector unsigned int)vec_sr(vec_splat_s32(-1),vec_splat_u32(9));
+    vconst2 = (vector unsigned int)vec_sr(vec_splat_s32(-1),vec_splat_u32(7));
+    vconst2 = vec_nor(vconst2,vconst2);
+    vconst3 = (vector signed int)vec_rl(vconst2,vec_splat_u32(7));
+    vshamt = vec_add(vec_splat_u32(9),vec_splat_u32(7));
+    vshamt = vec_add(vshamt,vec_splat_u32(7));
+    vconst2 = vec_sl((vector unsigned int)vconst3,vshamt);
+    
+    v1 = vec_ld(0,&x);
+    v2 = vec_perm(v1,v1,vec_lvsl(0,&x));
+    v3 = vec_splat(v2,0);
+    
+    v4 = (vector float)vec_sel(vconst2,(vector unsigned int)v3,vconst1);
+    v5 = vec_add(v4,vsqrt2);
+    v6 = vec_sub(v4,vsqrt2);
+    v7 = vec_re(v5);
+    vz = vec_madd(v6, vec_madd(vec_nmsub(v7,v5,(vector float)vconst2),v7,v7), vzero);
+    v8 = (vector float)vec_sr((vector unsigned int)v3,vshamt);
+    vlog = vec_ctf(vec_sub((vector signed int)v8,vconst3),0);
+    
+    vz2 = vec_madd(vz,vz,vzero);
+    vlog = vec_madd(vlog,vconst4,vhalf);
+    
+    v1 = vec_madd(vz2,vc,vb);
+    v2 = vec_madd(vz2,v1,va);
+    vlog = vec_madd(vz,v2,vlog);
+    
+    vec_ste(vlog,0,&out);
+    
+    return out;
+}
+
+void
+init_log_table(void)
+{
+}
+
+#else
 
 #define LOG2_SIZE       (512)
 #define LOG2_SIZE_L2    (9)
@@ -995,6 +1103,8 @@
     return log2val;
 }
 
+#endif
+
 #else /* Don't use FAST_LOG */
 
 
--- libmp3lame/util.h.orig	2011-05-08 01:05:17.000000000 +0900
+++ libmp3lame/util.h	2011-10-16 02:38:59.000000000 +0900
@@ -93,10 +93,17 @@
 
 /* log/log10 approximations */
 #ifdef USE_FAST_LOG
+#if defined(ALTIVEC) && !defined(ALTIVEC_970)
+#define         FAST_LOG10(x)       (fast_log10_altivec(x))
+#define         FAST_LOG(x)         (fast_loge_altivec(x))
+#define         FAST_LOG10_X(x,y)   (fast_log10_altivec(x)*(y))
+#define         FAST_LOG_X(x,y)     (fast_loge_altivec(x)*(y))
+#else
 #define         FAST_LOG10(x)       (fast_log2(x)*(LOG2/LOG10))
 #define         FAST_LOG(x)         (fast_log2(x)*LOG2)
 #define         FAST_LOG10_X(x,y)   (fast_log2(x)*(LOG2/LOG10*(y)))
 #define         FAST_LOG_X(x,y)     (fast_log2(x)*(LOG2*(y)))
+#endif
 #else
 #define         FAST_LOG10(x)       log10(x)
 #define         FAST_LOG(x)         log(x)
@@ -190,14 +197,14 @@
      */
 
     typedef struct {
-        FLOAT   masking_lower[CBANDS];
+        FLOAT   masking_lower[CBANDS] __attribute__ ((aligned (16)));
         FLOAT   minval[CBANDS];
         FLOAT   rnumlines[CBANDS];
         FLOAT   mld_cb[CBANDS];
         FLOAT   mld[Max(SBMAX_l,SBMAX_s)];
         FLOAT   bo_weight[Max(SBMAX_l,SBMAX_s)]; /* band weight long scalefactor bands, at transition */
         FLOAT   attack_threshold; /* short block tuning */
-        int     s3ind[CBANDS][2];
+        int     s3ind[CBANDS][4] __attribute__ ((aligned (16)));
         int     numlines[CBANDS];
         int     bm[Max(SBMAX_l,SBMAX_s)];
         int     bo[Max(SBMAX_l,SBMAX_s)];
@@ -222,7 +229,7 @@
 
     typedef struct {
 
-        FLOAT   nb_l1[4][CBANDS], nb_l2[4][CBANDS];
+        FLOAT   nb_l1[4][CBANDS] __attribute__ ((aligned (16))), nb_l2[4][CBANDS] __attribute__ ((aligned (16)));
         FLOAT   nb_s1[4][CBANDS], nb_s2[4][CBANDS];
 
         III_psy_xmin thm[4];
@@ -249,7 +256,7 @@
     /* variables used by encoder.c */
     typedef struct {
         /* variables for newmdct.c */
-        FLOAT   sb_sample[2][2][18][SBLIMIT];
+        FLOAT   sb_sample[2][2][18][SBLIMIT] __attribute__ ((aligned (16)));
         FLOAT   amp_filter[32];
 
         /* variables used by util.c */
@@ -296,7 +303,7 @@
 #ifndef  MFSIZE
 # define MFSIZE  ( 3*1152 + ENCDELAY - MDCTDELAY )
 #endif
-        sample_t mfbuf[2][MFSIZE];
+        sample_t mfbuf[2][MFSIZE] __attribute__ ((aligned (16)));
 
         int     mf_samples_to_encode;
         int     mf_size;
@@ -571,7 +578,12 @@
 
 /* log/log10 approximations */
     extern void init_log_table(void);
+#if defined(ALTIVEC) && !defined(ALTIVEC_970)
+    extern ieee754_float32_t fast_log10_altivec(ieee754_float32_t x);
+    extern ieee754_float32_t fast_loge_altivec(ieee754_float32_t x);
+#else
     extern ieee754_float32_t fast_log2(ieee754_float32_t x);
+#endif
 
     int     isResamplingNecessary(SessionConfig_t const* cfg);
 
--- libmp3lame/vbrquantize.c.orig	2012-02-08 03:15:00.000000000 +0900
+++ libmp3lame/vbrquantize.c	2012-02-08 17:32:36.000000000 +0900
@@ -26,6 +26,12 @@
 #  include <config.h>
 #endif
 
+#ifdef ALTIVEC
+#undef TAKEHIRO_IEEE754_HACK
+#ifndef __APPLE_CC__
+#include <altivec.h>
+#endif
+#endif
 
 #include "lame.h"
 #include "machine.h"
@@ -217,8 +223,23 @@
 static  FLOAT
 calc_sfb_noise_x34(const FLOAT * xr, const FLOAT * xr34, unsigned int bw, uint8_t sf)
 {
+#ifdef ALTIVEC
+    float vpow[8] __attribute__ ((aligned (16)));
+    vector float v0, v1, v2, v3, v4, v5, v6,v7,v8,v9,v10,v11,v12,v13;
+    vector unsigned char vperm1, vperm2,vc1,vc2,vc3;
+    vector signed int vl1,vl2,vl3;
+    vector float vxfsf, vsfpow, vsfpow34, vabs, vzero;
+    unsigned int s1,s2,s3,s4,s5,s6,s7,s8;
+    const vector float const1 = (vector float)VINIT4(0.4053964553387788,3.404263724373839,5.465086767819913,1.0);
+    const vector float const2 = (vector float)VINIT4(7.719205369637751,10.93017829043677,0,0);
+#ifdef ALTIVEC_970
+    vector unsigned int vmask1,vmask2,vmask3;
+#else
+    vector unsigned char vperm3,vperm4,vc4,vc5,vc6,vmask;
+#endif
+#endif
     DOUBLEX x[4];
-    int     l3[4];
+    int     l3[4] __attribute__ ((aligned (16)));
     const FLOAT sfpow = pow20[sf + Q_MAX2]; /*pow(2.0,sf/4.0); */
     const FLOAT sfpow34 = ipow20[sf]; /*pow(sfpow,-3.0/4.0); */
 
@@ -226,6 +247,239 @@
     unsigned int i = bw >> 2u;
     unsigned int const remaining = (bw & 0x03u);
 
+#ifdef ALTIVEC
+    vpow[0] = sfpow;
+    vpow[1] = sfpow34;
+    vsfpow = vec_ld(0,vpow);
+    vxfsf = vec_xor(vxfsf,vxfsf);
+    vsfpow34 = vec_splat(vsfpow,1);
+    vsfpow = vec_splat(vsfpow,0);
+    vperm1 = vec_lvsl(0,xr);
+    vperm2 = vec_lvsl(0,xr34);
+    v0 = vec_ld(0,xr);
+    v1 = vec_ld(0,xr34);
+    vabs = (vector float)vec_splat_s32(-1);
+    vabs = (vector float)vec_sl((vector unsigned int)vabs, (vector unsigned int)vabs);
+    vzero = vec_xor(vzero,vzero);
+#ifdef ALTIVEC_970
+    vc1 = vec_splat_u8(1);
+    vc2 = vec_splat_u8(5);
+    vc3 = vec_sl(vc1,vc2);
+    vmask1 = (vector unsigned int)vec_splat_s32(-1);
+    vmask1 = vec_sro(vmask1,vc3);
+    vmask2 = vec_sro(vmask1,vc3);
+    vmask3 = vec_sro(vmask2,vc3);
+#else
+    vperm3 = (vector unsigned char)VINIT16(0,0,0,0,0,0,0,0,0,1,2,3,16,17,18,19);
+    vperm4 = vec_sld(vperm3,(vector unsigned char)vzero,8);
+    vmask = (vector unsigned char)VINIT16ALL(16);
+#endif
+    for (; i > 1; i -= 2) {
+        
+        v2 = vec_ld(16,xr34);
+        v3 = vec_ld(32,xr34);
+        v4 = vec_perm(v1,v2,vperm2);
+        v5 = vec_perm(v2,v3,vperm2);
+        v12 = vec_madd(v4,vsfpow34,vzero);
+        v13 = vec_madd(v5,vsfpow34,vzero);
+        v1 = v3;
+        
+        v2 = vec_floor(v12);
+        v3 = vec_floor(v13);
+        v4 = vec_splat(const1,2);
+        v5 = vec_splat(const1,1);
+        v6 = vec_splat(const2,1);
+        v7 = vec_splat(const2,0);
+        v8 = vec_madd(v2,v4,v5);
+        v9 = vec_madd(v3,v4,v5);
+        v10 = vec_madd(v2,v6,v7);
+        v11 = vec_madd(v3,v6,v7);
+        v4 = vec_splat(const1,0);
+        v5 = vec_splat(const1,3);
+        v8 = vec_madd(v8,v2,v4);
+        v9 = vec_madd(v9,v3,v4);
+        v10 = vec_madd(v10,v2,v5);
+        v11 = vec_madd(v11,v3,v5);
+        v6 = vec_re(v10);
+        v7 = vec_re(v11);
+        v10 = vec_nmsub(v10,v6,v5);
+        v11 = vec_nmsub(v11,v7,v5);
+        v10 = vec_madd(v10,v6,v6);
+        v11 = vec_madd(v11,v7,v7);
+        v10 = vec_madd(v8,v10,v12);
+        v11 = vec_madd(v9,v11,v13);
+        
+        vl1 = vec_cts(v10,0);
+        vl2 = vec_cts(v11,0);
+        vl3 = (vector signed int)vec_pack(vl1,vl2);
+        vec_st(vl3,0,l3);
+        
+        s1 = l3[0] >> 16;
+        s2 = l3[0] & 0xffff;
+        s3 = l3[1] >> 16;
+        s4 = l3[1] & 0xffff;
+        s5 = l3[2] >> 16;
+        s6 = l3[2] & 0xffff;
+        s7 = l3[3] >> 16;
+        s8 = l3[3] & 0xffff;
+        
+#ifdef ALTIVEC_970
+        v2 = vec_lde(0,pow43+s1);
+        v3 = vec_lde(0,pow43+s2);
+        v4 = vec_lde(0,pow43+s3);
+        v5 = vec_lde(0,pow43+s4);
+        v2 = vec_perm(v2,v2,vec_lvsl(0,pow43+s1));
+        v3 = vec_perm(v3,v3,vec_lvsl(-4,pow43+s2));
+        v4 = vec_perm(v4,v4,vec_lvsl(-8,pow43+s3));
+        v5 = vec_perm(v5,v5,vec_lvsl(-12,pow43+s4));
+        v12 = vec_sel(v2,v3,vmask1);
+        v12 = vec_sel(v12,v4,vmask2);
+        v12 = vec_sel(v12,v5,vmask3);
+        
+        v2 = vec_lde(0,pow43+s5);
+        v3 = vec_lde(0,pow43+s6);
+        v4 = vec_lde(0,pow43+s7);
+        v5 = vec_lde(0,pow43+s8);
+        v2 = vec_perm(v2,v2,vec_lvsl(0,pow43+s5));
+        v3 = vec_perm(v3,v3,vec_lvsl(-4,pow43+s6));
+        v4 = vec_perm(v4,v4,vec_lvsl(-8,pow43+s7));
+        v5 = vec_perm(v5,v5,vec_lvsl(-12,pow43+s8));
+        v13 = vec_sel(v2,v3,vmask1);
+        v13 = vec_sel(v13,v4,vmask2);
+        v13 = vec_sel(v13,v5,vmask3);
+#else
+        vc1 = vec_lvsl(0,pow43+s1);
+        vc2 = vec_lvsl(0,pow43+s2);
+        vc3 = vec_lvsl(0,pow43+s3);
+        vc4 = vec_lvsl(0,pow43+s4);
+        vc2 = vec_or(vc2,vmask);
+        vc4 = vec_or(vc4,vmask);
+        v2 = vec_lde(0,pow43+s1);
+        v3 = vec_lde(0,pow43+s2);
+        v4 = vec_lde(0,pow43+s3);
+        v5 = vec_lde(0,pow43+s4);
+        vc5 = vec_perm(vc1,vc2,vperm3);
+        vc6 = vec_perm(vc3,vc4,vperm4);
+        v6 = vec_perm(v2,v3,vc5);
+        v7 = vec_perm(v4,v5,vc6);
+        v12 = vec_sld(v6,v7,8);
+        
+        vc1 = vec_lvsl(0,pow43+s5);
+        vc2 = vec_lvsl(0,pow43+s6);
+        vc3 = vec_lvsl(0,pow43+s7);
+        vc4 = vec_lvsl(0,pow43+s8);
+        vc2 = vec_or(vc2,vmask);
+        vc4 = vec_or(vc4,vmask);
+        v2 = vec_lde(0,pow43+s5);
+        v3 = vec_lde(0,pow43+s6);
+        v4 = vec_lde(0,pow43+s7);
+        v5 = vec_lde(0,pow43+s8);
+        vc5 = vec_perm(vc1,vc2,vperm3);
+        vc6 = vec_perm(vc3,vc4,vperm4);
+        v6 = vec_perm(v2,v3,vc5);
+        v7 = vec_perm(v4,v5,vc6);
+        v13 = vec_sld(v6,v7,8);
+#endif
+        
+        v2 = vec_ld(16, xr);
+        v3 = vec_ld(32, xr);
+        v6 = vec_perm(v0,v2,vperm1);
+        v7 = vec_perm(v2,v3,vperm1);
+        v0 = v3;
+        v8 = vec_andc(v6,vabs);
+        v9 = vec_andc(v7,vabs);
+        v10 = vec_nmsub(vsfpow, v12, v8);
+        v11 = vec_nmsub(vsfpow, v13, v9);
+        vxfsf = vec_madd(v10, v10, vxfsf);
+        vxfsf = vec_madd(v11, v11, vxfsf);
+        
+        xr += 8;
+        xr34 += 8;
+    }
+    if (i) {
+#ifdef ALTIVEC_970
+        x[0] = sfpow34 * xr34[0];
+        x[1] = sfpow34 * xr34[1];
+        x[2] = sfpow34 * xr34[2];
+        x[3] = sfpow34 * xr34[3];
+
+        k_34_4(x, l3);
+
+        vpow[0] = pow43[l3[0]];
+        vpow[1] = pow43[l3[1]];
+        vpow[2] = pow43[l3[2]];
+        vpow[3] = pow43[l3[3]];
+        v1 = vec_ld(0, vpow);
+        v2 = vec_ld(16, xr);
+        v3 = vec_perm(v0,v2,vperm1);
+        v4 = vec_andc(v3,vabs);
+        v5 = vec_nmsub(vsfpow, v1, v4);
+        vxfsf = vec_madd(v5, v5, vxfsf);
+#else
+        v2 = vec_ld(16,xr34);
+        v3 = vec_perm(v1,v2,vperm2);
+        v4 = vec_madd(v3,vsfpow34,vzero);
+        vl1 = vec_cts(v4,0);
+        vec_st(vl1,0,l3);
+        
+        v5 = vec_lde(0,adj43+l3[0]);
+        v6 = vec_lde(0,adj43+l3[1]);
+        v7 = vec_lde(0,adj43+l3[2]);
+        v8 = vec_lde(0,adj43+l3[3]);
+        v9 = vec_perm(v5,v5,vec_lvsl(0,adj43+l3[0]));
+        v10 = vec_perm(v6,v6,vec_lvsl(-4,adj43+l3[1]));
+        v11 = vec_perm(v7,v7,vec_lvsl(-8,adj43+l3[2]));
+        v12 = vec_perm(v8,v8,vec_lvsl(-12,adj43+l3[3]));
+        v9 = vec_or(v9,v10);
+        v9 = vec_or(v9,v11);
+        v9 = vec_or(v9,v12);
+        
+        v10 = vec_add(v4,v9);
+        vl1 = vec_cts(v10,0);
+        vec_st(vl1,0,l3);
+        
+        v2 = vec_lde(0,pow43+l3[0]);
+        v3 = vec_lde(0,pow43+l3[1]);
+        v4 = vec_lde(0,pow43+l3[2]);
+        v5 = vec_lde(0,pow43+l3[3]);
+        v6 = vec_perm(v2,v2,vec_lvsl(0,pow43+l3[0]));
+        v7 = vec_perm(v3,v3,vec_lvsl(-4,pow43+l3[1]));
+        v8 = vec_perm(v4,v4,vec_lvsl(-8,pow43+l3[2]));
+        v9 = vec_perm(v5,v5,vec_lvsl(-12,pow43+l3[3]));
+        v6 = vec_or(v6,v7);
+        v6 = vec_or(v6,v8);
+        v6 = vec_or(v6,v9);
+        
+        v2 = vec_ld(16, xr);
+        v3 = vec_perm(v0,v2,vperm1);
+        v4 = vec_andc(v3,vabs);
+        v5 = vec_nmsub(vsfpow, v6, v4);
+        vxfsf = vec_madd(v5, v5, vxfsf);
+#endif
+        xr += 4;
+        xr34 += 4;
+    }
+	if (remaining) {
+        x[0] = x[1] = x[2] = x[3] = 0;
+        switch( remaining ) {
+        case 3: x[2] = sfpow34 * xr34[2];
+        case 2: x[1] = sfpow34 * xr34[1];
+        case 1: x[0] = sfpow34 * xr34[0];
+        }
+
+        k_34_4(x, l3);
+        x[0] = x[1] = x[2] = x[3] = 0;
+
+        switch( remaining ) {
+        case 3: x[2] = fabsf(xr[2]) - sfpow * pow43[l3[2]];
+        case 2: x[1] = fabsf(xr[1]) - sfpow * pow43[l3[1]];
+        case 1: x[0] = fabsf(xr[0]) - sfpow * pow43[l3[0]];
+        }
+        xfsf += (x[0] * x[0] + x[1] * x[1]) + (x[2] * x[2] + x[3] * x[3]);
+    }
+    vec_st(vxfsf,0,vpow);
+    return xfsf + vpow[0] + vpow[1] + vpow[2] + vpow[3];
+#else
     while (i-- > 0) {
         x[0] = sfpow34 * xr34[0];
         x[1] = sfpow34 * xr34[1];
@@ -262,6 +516,7 @@
         xfsf += (x[0] * x[0] + x[1] * x[1]) + (x[2] * x[2] + x[3] * x[3]);
     }
     return xfsf;
+#endif
 }
 
 
